/*
 * Main.java
 *
 * Created on 25 May 2009, 12:55
 *
 * @author Dr eng Neculai AVRAMIUC, National Agency for Cadastre and Land Registration
 *                Bucharest, Romania, http://ancpi.ro, tel/fax 004 021 2240614
 *
 */

package transdatro_code_source;

import java.util.*;
import java.io.*;

public class Main {
    
    public Main() {
    }
    public static void main(String[] args) throws IOException { 
     
      int choice=-1;
      int error=0; 
      double dd_phi=0, mm_phi=0, ss_phi=0;
      double dd_la=0, mm_la=0, ss_la=0;
      double phi=0, _la=0, _h=0;
      double xSt=0, ySt=0, hMN=0;
      String buff="";
      String token="";
      BufferedReader fluxIntrare = new BufferedReader(new InputStreamReader(System.in));
      StringTokenizer st = new StringTokenizer("");
      Scanner in = new Scanner(System.in);
      ETRS89Stereo7030HMN eStHMN = new ETRS89Stereo7030HMN();
      Stereo7030HMNETRS89 stHMNE = new Stereo7030HMNETRS89();
      // get input
      System.out.println("TransDatRO_code_source.jar (version 1.01/25.11.2009)");
      System.out.println("---------------------------------------------------");
      while (choice != 0){
        System.out.println();
        error=0;
        System.out.println("Make your choice:");
        System.out.println("< 1 > ETRS89 to Stereografic 1970 and Marea Neagra 1975");
        System.out.println("< 2 > Stereografic 1970 and Marea Neagra 1975 to ETRS89");
        System.out.println("< 3 > ETRS89 to Stereografic 1930 and Marea Neagra 1975");
        System.out.println("< 4 > Stereografic 1930 and Marea Neagra 1975 to ETRS89");
        System.out.println("< 0 > Exit");
        System.out.println("Choice: ");
        choice = in.nextInt();
        switch (choice)
        {
        case 1:
          System.out.println("");
          System.out.println("Enter latitude (  '  '')  (pattern: 44 44 44.44444): ");
          buff = fluxIntrare.readLine();
          st = new StringTokenizer(buff); 
          if (st.countTokens()==3) {   
            token = st.nextElement().toString();            
            dd_phi = Double.valueOf(token).doubleValue();  
            token = st.nextElement().toString(); 
            mm_phi = Double.valueOf(token).doubleValue();
            token = st.nextElement().toString(); 
            ss_phi = Double.valueOf(token).doubleValue();
            //Conversion in degrees
            phi=dd_phi+mm_phi/60+ss_phi/3600;
          }
          else{
            System.out.println("Error input!");
            break;
          }
          System.out.println("Enter longitude (  '  '') (pattern: 22 22 22.22222): ");
          buff = fluxIntrare.readLine();
          st = new StringTokenizer(buff); 
          if (st.countTokens()==3) {   
            token = st.nextElement().toString();            
            dd_la = Double.valueOf(token).doubleValue();
            token = st.nextElement().toString(); 
            mm_la = Double.valueOf(token).doubleValue();
            token = st.nextElement().toString(); 
            ss_la = Double.valueOf(token).doubleValue();
            //Conversion in degrees
            _la=dd_la+mm_la/60+ss_la/3600;
          }
          else{
            System.out.println("Input Data Errors!");
            break;
          }    
          System.out.println("Enter ellipsoidal height (meters) (pattern: 777.777): ");
          buff = fluxIntrare.readLine(); 
          _h = Double.valueOf(buff).doubleValue();
          error=eStHMN.doCompTrans(phi, _la, _h,70);
          if (error==0) {
            xSt=eStHMN.getNorth();
            ySt=eStHMN.getEast();
            hMN=eStHMN.gethMN();  
            System.out.println("");
            System.out.printf("Stereographic_70 x (North)= %11.3f %n",xSt);
            System.out.printf("Stereographic_70 y (East) = %11.3f %n",ySt);
            System.out.printf("Marea_Neagra_75  H        = %11.3f %n",hMN);
          }
          else {
            System.out.println("Input Data Errors!");
            break;  
          }
          break;
        case 2:
          System.out.println("");
          System.out.println("Enter Stereographic_70 x (North) (meters): ");
          buff = fluxIntrare.readLine();
          xSt = Double.valueOf(buff).doubleValue();
          System.out.println("Enter Stereographic_70 y (East)  (meters): ");
          buff = fluxIntrare.readLine();
          ySt = Double.valueOf(buff).doubleValue();
          System.out.println("Enter Marea_Neagra_75  H         (meters): ");
          buff = fluxIntrare.readLine(); 
          hMN = Double.valueOf(buff).doubleValue();
          error=stHMNE.doCompTrans(ySt,xSt,hMN,70);
          if (error==0) {
            phi=stHMNE.getphi();
            _la=stHMNE.getla();
            _h=stHMNE.geth();
            deg_ddmmss dms=new deg_ddmmss();
            System.out.println("");
            dms.degToDMS(phi);
            System.out.printf("ETRS89 phi    = %2.0f %2.0f %8.5f %n",dms.getdd(),
                    dms.getmm(),dms.getss());
            dms.degToDMS(_la);
            System.out.printf("ETRS89 lambda = %2.0f %2.0f %8.5f %n",dms.getdd(),
                    dms.getmm(),dms.getss());
            System.out.printf("ETRS89 h      =  %11.3f %n",_h);
          }
          else {
            System.out.println("Input Data Errors!");
            break;  
          }
          break;  
        case 3:
          System.out.println("");
          System.out.println("Enter latitude (  '  '')  (pattern: 44 44 44.44444): ");
          buff = fluxIntrare.readLine();
          st = new StringTokenizer(buff); 
          if (st.countTokens()==3) {   
            token = st.nextElement().toString();            
            dd_phi = Double.valueOf(token).doubleValue();  
            token = st.nextElement().toString(); 
            mm_phi = Double.valueOf(token).doubleValue();
            token = st.nextElement().toString(); 
            ss_phi = Double.valueOf(token).doubleValue();
            //Conversion in degrees
            phi=dd_phi+mm_phi/60+ss_phi/3600;
          }
          else{
            System.out.println("Error input!");
            break;
          }
          System.out.println("Enter longitude (  '  '') (pattern: 25 25 25.25252): ");
          buff = fluxIntrare.readLine();
          st = new StringTokenizer(buff); 
          if (st.countTokens()==3) {   
            token = st.nextElement().toString();            
            dd_la = Double.valueOf(token).doubleValue();
            token = st.nextElement().toString(); 
            mm_la = Double.valueOf(token).doubleValue();
            token = st.nextElement().toString(); 
            ss_la = Double.valueOf(token).doubleValue();
            //Conversion in degrees
            _la=dd_la+mm_la/60+ss_la/3600;
          }
          else{
            System.out.println("Input Data Errors!");
            break;
          }    
          System.out.println("Enter ellipsoidal height (meters) (pattern: 111.111): ");
          buff = fluxIntrare.readLine(); 
          _h = Double.valueOf(buff).doubleValue();
          error=eStHMN.doCompTrans(phi, _la, _h, 30);
          if (error==0) {
            xSt=eStHMN.getEast();
            ySt=eStHMN.getNorth();
            hMN=eStHMN.gethMN(); 
            System.out.println("");
            System.out.printf("Stereographic_30 x (East) = %11.3f %n",xSt);
            System.out.printf("Stereographic_30 y (North)= %11.3f %n",ySt);
            System.out.printf("Marea_Neagra_75  H        = %11.3f %n",hMN);
          }
          else {
            System.out.println("Input Data Errors!");
            break;  
          }
          break;  
        case 4:
          System.out.println("");
          System.out.println("Enter Stereographic_30 x (East) (meters): ");
          buff = fluxIntrare.readLine();
          xSt = Double.valueOf(buff).doubleValue();
          System.out.println("Enter Stereographic_30 y (North)  (meters): ");
          buff = fluxIntrare.readLine();
          ySt = Double.valueOf(buff).doubleValue();
          System.out.println("Enter Marea_Neagra_75  H         (meters): ");
          buff = fluxIntrare.readLine(); 
          hMN = Double.valueOf(buff).doubleValue();
          error=stHMNE.doCompTrans(xSt,ySt,hMN,30);
          if (error==0) {
            phi=stHMNE.getphi();
            _la=stHMNE.getla();
            _h=stHMNE.geth();
            deg_ddmmss dms=new deg_ddmmss();
            System.out.println("");
            dms.degToDMS(phi);
            System.out.printf("ETRS89 phi    = %2.0f %2.0f %8.5f %n",dms.getdd(),
                    dms.getmm(),dms.getss());
            dms.degToDMS(_la);
            System.out.printf("ETRS89 lambda = %2.0f %2.0f %8.5f %n",dms.getdd(),
                    dms.getmm(),dms.getss()); 
            System.out.printf("ETRS89 h      =  %11.3f %n",_h);
          }
          else {
            System.out.println("Input Data Errors!");
            break;  
          }
          break;
        case 0:
          System.out.println("End of Program");  
          return;    
        default:
          // bad input
          System.out.println("Wrong choice! Your choice must be in (0, 1, 2, 3, 4)");
          break;
      } 
    } 
  }
}  
class dV //Default Values
{ 
    //* Grid File Names *
      static String NameFilegrdz="EGG97_QGRJ.GRD";
      static String NameFilegrd_R="ETRS89_KRASOVSCHI42_2DJ.GRD";
      static String NameFilegrd_B="ETRS89_Stereo30_2DJ.GRD";
/*    
 *     Grd files are Delphi binary files with the types:
 *    - double for EGG97_QGRJ.GRD
 *    - record for ETRS89_KRASOVSCHI42_2DJ.GRD and ETRS89_Stereo30_2DJ.GRD with
 *      a declaration like this:
 *        tnod=record
 *          dE, dN:real;
 *        end;  
 *      Note: In Delphi, real=double.
 *    Each of the grid files has a header (minE, maxE, minN, maxN, stepE, stepN),
 *    and then the data records are writen consecutively in rows from lower left 
 *    corner to the uper right corner starting with position 6 (positions 0..5 
 *    are for header): 
 *                size_N . . . . . . .  . .
 *                   .                    .
 *                   .                    .
 *                   6, 7, 8, . . . . . size_E
 *    For 2D grid files, the order is: dE1, dN1, dE2, dN2, etc.
 */ 
             
      //* Parameters of ellipsoid GRS80 *
      static double A_ETRS89 = 6378137;
      static double INV_F_ETRS89 = 298.257222101;

      //* Helmert 2D Transformation parameters:
      
      //* Oblique_Stereographic_GRS80 to Stereografic 1970 *
      static double tE_OS_St70 = 119.7358; //{translation in direction of East in meters}
      static double tN_OS_St70 = 31.8051;  //{translation in direction of North in meters}
      static double dm_OS_St70 = 0.11559991; //{scale parameter in ppm (scale m = 1+dm*1e-6)}
      static double Rz_OS_St70 = -0.22739706; //{rotation around z axis in seconds ('')}

      //* Stereografic 1970 to Oblique_Stereographic_GRS80 *
      static double tE_St70_OS = -119.7358; //{translation in direction of East in meters}
      static double tN_St70_OS = -31.8051;  //{translation in direction of North in meters}
      static double dm_St70_OS = -0.11559991; //{scale parameter in ppm (scale m = 1+dm*1e-6)}
      static double Rz_St70_OS = 0.22739706; //{rotation around z axis in seconds ('')}

      //* Oblique_Stereographic_GRS80 to Stereografic 1930 *
      static double tE_OS_St30 = -32701.3610; //{translation in direction of East in meters}
      static double tN_OS_St30 = 13962.1632;  //{translation in direction of North in meters}
      static double dm_OS_St30 = 13.97707176; //{scale parameter in ppm (scale m = 1+dm*1e-6)}
      static double Rz_OS_St30 = -1006.26886396; //{rotation around z axis in seconds ('')}

      //* Stereografic 1930 to Oblique_Stereographic_GRS80 *
      static double tE_St30_OS = 32768.6284; //{translation in direction of East in meters}
      static double tN_St30_OS = -13802.2702;  //{translation in direction of North in meters}
      static double dm_St30_OS = -13.97689927; //{scale parameter in ppm (scale m = 1+dm*1e-6)}
      static double Rz_St30_OS = 1006.26886393; //{rotation around z axis in seconds ('')}  
}
class deg_ddmmss
 {
    public double getdd()
    {
       return dd;
    }
    public double getmm()
    {
       return mm;
    }
     public double getss()
    {
       return ss;
    }
    public void degToDMS(double deg)
    {
      dd=(int)deg;
      mm=(int)((deg-dd)*60);
      ss=((deg-dd)*60-mm)*60;
    }
    private double dd;
    private double mm;
    private double ss;
 }
class Stereo_FiLa_NE
{
    Stereo_FiLa_NE(double ca, double cnf){
        a=ca;
        nf=cnf;
    }
    public double getNorth()
    {
       return North;
    }
    public double getEast()
    {
       return East;
    }
    public void doConversion1 (double Fi, double La)
    {
      double raza,k0,c;
      double b,ep,f;
      double n,s1,s2,w1,w2,hi0,hi,beta;
      double w,sa,sb,lam;
      double br1,la0;
      
      br1=46*Math.PI/180;
      la0=25*Math.PI/180;
      k0=0.99975;
      f=1/nf;
      b=a*(1-f);
      ep=Math.sqrt((a*a-b*b)/(a*a));
      w=Math.sqrt(1-ep*ep*(Math.sin(br1))*(Math.sin(br1)));
      raza=(a*(1-ep*ep))/(w*w*w);
      raza=Math.sqrt(raza*a/w);
      n=Math.sqrt(1+(ep*ep*Math.cos(br1)*Math.cos(br1)*Math.cos(br1)*Math.cos(br1))/(1-ep*ep));
      s1=(1+Math.sin(br1))/(1-Math.sin(br1));
      s2=(1-ep*Math.sin(br1))/(1+ep*Math.sin(br1));
      w1=Math.exp(n*Math.log(s1*Math.exp(ep*Math.log(s2))));
      c=((n+Math.sin(br1))*(1-(w1-1)/(w1+1)))/((n-Math.sin(br1))*(1+(w1-1)/(w1+1)));
      w2=c*w1;
      hi0=(w2-1)/(w2+1);
      hi0=Math.atan(hi0/Math.sqrt(1-hi0*hi0));
      sa=(1+Math.sin(Fi))/(1-Math.sin(Fi));
      sb=(1-ep*Math.sin(Fi))/(1+ep*Math.sin(Fi));
      w=c*Math.exp(n*Math.log(sa*Math.exp(ep*Math.log(sb))));
      hi=(w-1)/(w+1);
      hi=Math.atan(hi/Math.sqrt(1-hi*hi));
      lam=n*(La-la0)+la0;
      beta=1+Math.sin(hi)*Math.sin(hi0)+Math.cos(hi)*Math.cos(hi0)*Math.cos(lam-la0);
      East=2*raza*k0*Math.cos(hi)*Math.sin(lam-la0)/beta;
      North=2*raza*k0*(Math.cos(hi0)*Math.sin(hi)-Math.sin(hi0)*Math.cos(hi)*Math.cos(lam-la0))/beta;
      North=North+500000;
      East=East+500000;
    }
    private double a;
    private double nf;
    private double North; 
    private double East;  
}  
class Stereo_NE_FiLa{
    Stereo_NE_FiLa(double ca, double cnf){
        a=ca;
        nf=cnf;
    }
    public double getFi()
    {
       return Fi;
    }
    public double getLa()
    {
       return La;
    }
    public void doConversion2 (double North, double East)
    {
        double br1,la0,c;
        double ep,f;
        double fic;
        double tol;
        double lam,csi,csii;
        int i;
        double k0,n,s1,s2,w1,w2,w;
        double g,h,ii,j,raza,b;
        double fn,fe;
        double dif;
        double hi0,hi;
        Fi=0; La=0;
        br1=46*Math.PI/180;
        la0=25*Math.PI/180;
        k0=0.99975;

        f=1/nf;
        b=a*(1-f);
        ep=Math.sqrt((a*a-b*b)/(a*a));
        w=Math.sqrt(1-ep*ep*(Math.sin(br1))*(Math.sin(br1)));
        raza=(a*(1-ep*ep))/(w*w*w);
        raza=Math.sqrt(raza*a/w);
        n=(ep*ep*Math.cos(br1)*Math.cos(br1)*Math.cos(br1)*Math.cos(br1))/(1-ep*ep);
        n=Math.sqrt(1+n);
        s1=(1+Math.sin(br1))/(1-Math.sin(br1));
        s2=(1-ep*Math.sin(br1))/(1+ep*Math.sin(br1)); 
        w1=Math.exp(n*Math.log(s1*Math.exp(ep*Math.log(s2))));
        c=((n+Math.sin(br1))*(1-(w1-1)/(w1+1)))/((n-Math.sin(br1))*(1+(w1-1)/(w1+1)));
        w2=c*w1;

        hi0=(w2-1)/(w2+1);
        hi0=Math.atan(hi0/Math.sqrt(1-hi0*hi0));
        g=2*raza*k0*Math.tan(Math.PI/4-hi0/2);
        h=4*raza*k0*Math.tan(hi0)+g;
        fn=500000;
        fe=500000;

        ii=Math.atan((East-fe)/(h+(North-fn)));
        j=Math.atan((East-fe)/(g-(North-fn)))-ii;
        lam=j+2*ii+la0;
        La=la0+(lam-la0)/n;
        hi=hi0+2*Math.atan((North-fn-(East-fe)*Math.tan(j/2))/(2*raza*k0));
        csi=(0.5*Math.log((1+Math.sin(hi))/(c*(1-Math.sin(hi)))))/n;
        Fi=2*Math.atan(Math.exp(csi))-Math.PI/2;
        i=0;
        tol=0.000001;
        dif=100;
        while ((dif>tol) && (i<50)) {
          i=i+1;
          fic=Fi;
          csii=Math.log(Math.tan(Fi/2+Math.PI/4)*Math.exp((ep/2)*
               Math.log((1-ep*Math.sin(Fi))/(1+ep*Math.sin(Fi)))));
          Fi=Fi-(csii-csi)*Math.cos(Fi)*(1-ep*ep*(Math.sin(Fi))*(Math.sin(Fi)))/(1-ep*ep);
          dif=Math.abs(Fi*180*60*60/Math.PI-fic*180*60*60/Math.PI);
        }  
    }
    private double a;
    private double nf;
    private double Fi;
    private double La;
}
class Helmert2D {
    Helmert2D (double ctE, double ctN, double cdm, double cRz){
        tE=ctE;
        tN=ctN;
        dm=cdm;
        Rz=cRz;
    }
    public double getEastt()
    {
       return Eastt;
    }
    public double getNortht()
    {
       return Northt;
    }
    public void doTransformation(double Easts, double Norths)
    {
       double m;
       m=1+dm*1e-6;
       //{Conversion '' to radians}
       Rz=Rz*Math.PI/(180*3600);
       Eastt=Easts*m*Math.cos(Rz)-Norths*m*Math.sin(Rz)+tE;
       Northt=Norths*m*Math.cos(Rz)+Easts*m*Math.sin(Rz)+tN;
    }
    private double tE;
    private double tN;
    private double dm;
    private double Rz;
    private double Eastt; 
    private double Northt; 
}
class BSplineInterpolation 
 {
    public double getShift_value()
    {
       return shift_value;
    }

    public void doBSInterpolation(double[] ff, double[] az)
    {
       double[] cf=new double[17];   
       /*{Matching interpolated surface at the corners of the unit square (6, 7, 11, 10)}
        *in the grid patch:
        *       13  14  15  16
        *
        *        9  10  11  12
        *              X
        *        5   6   7   8
        *
        *        1   2   3   4 }
        */
       cf[1]=az[6];
       cf[2]=az[7];
       cf[3]=az[10];
       cf[4]=az[11];
       
       //{Derivatives in the East-direction and the North-direction}
       cf[5]=(-az[8]+4*az[7]-3*az[6])/2;
       cf[6]=(3*az[7]-4*az[6]+az[5])/2;
       cf[7]=(-az[12]+4*az[11]-3*az[10])/2;
       cf[8]=(3*az[11]-4*az[10]+az[9])/2;
       cf[9]=(-az[14]+4*az[10]-3*az[6])/2;
       cf[10]=(-az[15]+4*az[11]-3*az[7])/2;
       cf[11]=(3*az[10]-4*az[6]+az[2])/2;
       cf[12]=(3*az[11]-4*az[7]+az[3])/2;
   
       //{Equations for the cross derivative}
       cf[13]=((az[1]+az[11])-(az[3]+az[9]))/4;
       cf[14]=((az[2]+az[12])-(az[4]+az[10]))/4;
       cf[15]=((az[5]+az[15])-(az[7]+az[13]))/4;
       cf[16]=((az[6]+az[16])-(az[8]+az[14]))/4;

       //{Determining the 16 unknown coefficients of the interpolated surface}
       az[1]=cf[1];
       az[2]=cf[5];
       az[3]=-3*cf[1]+3*cf[2]-2*cf[5]-cf[6];
       az[4]=2*cf[1]-2*cf[2]+cf[5]+cf[6];
       az[5]=cf[9];
       az[6]=cf[13];
       az[7]=-3*cf[9]+3*cf[10]-2*cf[13]-cf[14];
       az[8]=2*cf[9]-2*cf[10]+cf[13]+cf[14];
       az[9]=-3*cf[1]+3*cf[3]-2*cf[9]-cf[11];
       az[10]=-3*cf[5]+3*cf[7]-2*cf[13]-cf[15];
       az[11]=9*cf[1]-9*cf[2]-9*cf[3]+9*cf[4]+6*cf[5]+3*cf[6]-6*cf[7]-3*cf[8]+
          6*cf[9]-6*cf[10]+3*cf[11]-3*cf[12]+4*cf[13]+2*cf[14]+2*cf[15]+cf[16];
       az[12]=-6*cf[1]+6*cf[2]+6*cf[3]-6*cf[4]-3*cf[5]-3*cf[6]+3*cf[7]+3*cf[8]-
          4*cf[9]+4*cf[10]-2*cf[11]+2*cf[12]-2*cf[13]-2*cf[14]-cf[15]-cf[16];
       az[13]=2*cf[1]-2*cf[3]+cf[9]+cf[11];
       az[14]=2*cf[5]-2*cf[7]+cf[13]+cf[15];
       az[15]=-6*cf[1]+6*cf[2]+6*cf[3]-6*cf[4]-4*cf[5]-2*cf[6]+4*cf[7]+2*cf[8]-
          3*cf[9]+3*cf[10]-3*cf[11]+3*cf[12]-2*cf[13]-cf[14]-2*cf[15]-cf[16];
       az[16]=4*cf[1]-4*cf[2]-4*cf[3]+4*cf[4]+2*cf[5]+2*cf[6]-2*cf[7]-2*cf[8]+
          2*cf[9]-2*cf[10]+2*cf[11]-2*cf[12]+cf[13]+cf[14]+cf[15]+cf[16];
       shift_value=0;
       for (int ii = 1; ii < cf.length; ii++){
          shift_value=shift_value+az[ii]*ff[ii]; 
       }
    }
    private double shift_value;     
 }
class Interpolation_1D
 {
    public Interpolation_1D(double cphi, double cla, String cfileName){   
       phi=cphi;
       la=cla;
       fileName=cfileName;
    } 
    public double getShift_value1()
    {
       return shift_value1;
    }
    protected static double readFP(RandomAccessFile in) throws java.io.IOException 
    { 
      byte a, b, c, d, e, f, g, h; 
      a = in.readByte(); 
      b = in.readByte(); 
      c = in.readByte(); 
      d = in.readByte(); 
      e = in.readByte();
      f = in.readByte();
      g = in.readByte();
      h = in.readByte();
      byte[] ba = { h, g, f, e, d, c, b, a }; 
      DataInputStream dis = new DataInputStream(new 
      ByteArrayInputStream(ba)); 
      double x = dis.readDouble(); 
      return x; 
    } 
    protected int loadArrays(RandomAccessFile in){     
       double xk, yk;//  {xk=East, yk=North}
       double gridValue;
       long nrjx, nodcolx, nodliny;
       double minE, maxE, minN, maxN, stepE, stepN;
       
       //{Read Grid File Header}
       try{
          in.seek(0);
          minE=readFP(in);
          maxE=readFP(in);
          minN=readFP(in);
          maxN=readFP(in);
          stepE=readFP(in);
          stepN=readFP(in);
       }
       catch(IOException e)
       {
          e.printStackTrace();
          return -1;
       } 
       nrjx=Math.round((maxE-minE)/stepE+1); //{number of columns}
       if ((la<=(minE+stepE)) || (la>=(maxE-stepE)) ||
          (phi<=(minN+stepN)) || (phi>=(maxN-stepN))){
          System.out.println("Error: Outside bounding box of "+fileName);
          return -1;
       }
       nodcolx=Math.abs(Math.round((int)((la-minE)/stepE))); //{(column-1) of point 6}
       nodliny=Math.abs(Math.round((int)((phi-minN)/stepN))); //{(row-1) of point 6}
       xk=minE+nodcolx*stepE; //{lambda of point 6 / East of point 6}
       yk=minN+nodliny*stepN; //{phi of point 6 / North of point 6}
       
       //{relative coordinate of point X:}
       xk=(la-xk)/stepE;
       yk=(phi-yk)/stepN;
       
       //{Parameters of bicubic spline surface}
       ff[1]=1;
       ff[2]=xk;
       ff[3]=xk*xk;
       ff[4]=xk*xk*xk;
       ff[5]=yk;
       ff[6]=xk*yk;
       ff[7]=xk*xk*yk;
       ff[8]=xk*xk*xk*yk;
       ff[9]=yk*yk;
       ff[10]=xk*yk*yk;
       ff[11]=xk*xk*yk*yk;
       ff[12]=xk*xk*xk*yk*yk;
       ff[13]=yk*yk*yk;
       ff[14]=xk*yk*yk*yk;
       ff[15]=xk*xk*yk*yk*yk;
       ff[16]=xk*xk*xk*yk*yk*yk;
  
       //{Positions in grid file}
       nc[6]=(nodliny)*nrjx+nodcolx+1;
       nc[1]=(nodliny-1)*nrjx+nodcolx;
       nc[2]=(nodliny-1)*nrjx+nodcolx+1;
       nc[3]=(nodliny-1)*nrjx+nodcolx+2;
       nc[4]=(nodliny-1)*nrjx+nodcolx+3;
       nc[5]=(nodliny)*nrjx+nodcolx;
       nc[7]=(nodliny)*nrjx+nodcolx+2;
       nc[8]=(nodliny)*nrjx+nodcolx+3;
       nc[9]=(nodliny+1)*nrjx+nodcolx;
       nc[10]=(nodliny+1)*nrjx+nodcolx+1;
       nc[11]=(nodliny+1)*nrjx+nodcolx+2;
       nc[12]=(nodliny+1)*nrjx+nodcolx+3;
       nc[13]=(nodliny+2)*nrjx+nodcolx;
       nc[14]=(nodliny+2)*nrjx+nodcolx+1;
       nc[15]=(nodliny+2)*nrjx+nodcolx+2;
       nc[16]=(nodliny+2)*nrjx+nodcolx+3;
       return 0;
    }
    public int doInterpolation()
    {
       int error=0;
       double[] az=new double[17];
       double value=0;
       int outside=0;
       try {
         RandomAccessFile xin = new RandomAccessFile(fileName, "r");  
         error=loadArrays(xin);
         if (error==0){
            //{Read grid file values}
            try{
               for (int ii=1; ii<=16; ii++){
                  xin.seek(nc[ii]*8-8+48); //{6*8=48 length of header}
                  value=readFP(xin);
                  if (Math.round((int)(value))==999){
                      outside=-1;
                  }
                  az[ii]=value;    
               }
               xin.close();
            }
            catch(IOException e)
            {
              e.printStackTrace();
               return -1;
            } 
            if (outside!=0){
               System.out.println("Error: Outside of border");
               return -1;  
            }
            BSplineInterpolation bsi=new BSplineInterpolation();
            bsi.doBSInterpolation(ff, az);
            shift_value1=bsi.getShift_value();
         }
         else{
            return -1; 
         }
       }
       catch(IOException e)
       {
         e.printStackTrace();
          return -1;
       } 
       return 0;   
    }
    private double phi;
    private double la;
    private String fileName;
    private double shift_value1;
    protected long[] nc=new long[17];
    protected double[] ff=new double[17];
 }
class Interpolation_2D extends Interpolation_1D{
    public Interpolation_2D(double cEast, double cNorth, String cfileName){
       super(cNorth, cEast, cfileName); 
       fileName=cfileName;    
    }
    public double getShift_value_E()
    {
       return shift_value_E;
    }
     public double getShift_value_N()
    {
       return shift_value_N;
    }
    public int doInterpolation() 
    {
       int error=0;
       double[] ax=new double[17];
       double[] ay=new double[17];
       double value=0;
       int outside=0;
       try{
         RandomAccessFile xin = new RandomAccessFile(fileName, "r");  
         error=loadArrays(xin);
         if (error==0){
            //{Read grid file values}
            try{  
               for (int ii=1; ii<=16; ii++){
                  xin.seek(nc[ii]*16-16+48); //{6*8=48 length of header}
                  value=readFP(xin);
                  if (Math.round((int)(value))==999){
                      outside=-1;
                  }
                  ax[ii]=value; 
                  xin.seek(nc[ii]*16-8+48); //{6*8=48 length of header}
                  value=readFP(xin);
                  if (Math.round((int)(value))==999){
                      outside=-1;
                  }
                  ay[ii]=value; 
               }
               xin.close();
            }
            catch(IOException e)
            {
              e.printStackTrace();
               return -1;
            }
            if (outside!=0){
              System.out.println("Error: Outside of border");
              return -1;  
            }
            BSplineInterpolation bsi=new BSplineInterpolation();
            bsi.doBSInterpolation(ff, ax);
            shift_value_E=bsi.getShift_value();
            bsi.doBSInterpolation(ff, ay);
            shift_value_N=bsi.getShift_value();
         }
         else{
            return -1; 
         }
       }
       catch(IOException e)
       {
          e.printStackTrace();
          return -1;
       }
       return 0;   
    }
    private String fileName;
    private double shift_value_E;
    private double shift_value_N;   
}

//{Transformation (ellipsoidal height)_ETRS89 to (normal height)_Marea_Neagra_1975
//(Black Sea 1975) using the quasigeoid}
class ETRS89HMN {
   public double gethMN()
   {
      return hMN;
   } 
   public int doTransformation(double phi, double la, double h) {
      double shift_value; 
      int error=0;
      Interpolation_1D int1D=new Interpolation_1D(phi, la, dV.NameFilegrdz);
      error=int1D.doInterpolation();
      if (error==0){
        shift_value=int1D.getShift_value1();
        hMN=h-shift_value;
      }
      else{
         return -1; 
      }   
      return 0; 
   }
   private double hMN;
}
//{Transformation (normal height)_Marea_Neagra_1975 to (ellipsoidal height)_ETRS89
//using the quasigeoid}
class HMNETRS89{
   public double geth()
   {
      return h;
   } 
    public int doTransformation(double phi, double la, double hMN) {
      double shift_value; 
      int error=0;
      Interpolation_1D int1D=new Interpolation_1D(phi, la, dV.NameFilegrdz);
      error=int1D.doInterpolation();
      if (error==0){
        shift_value=int1D.getShift_value1();
        h=hMN+shift_value;
      }
      else{
        return -1; 
      } 
      return 0; 
   }
   private double h;
}
//{Transformation ETRS89 to Stereografic 1970 or Stereografic 1930}
class ETRS89Stereo70or30{
   public double getEast()
   {
      return East;
   } 
   public double getNorth()
   {
      return North;
   }
   public int doTransformation(double phi, double la, int type70or30) {
   // Note: x_Stereo70=North, yStereo70=East; x_Stereo30=East, y_stereo30=North       
   //       phi, la in radians 
   //       type70or30=70 for Stereo70, and type70or30=30 for Stereo30
      double EastS, NorthS;
      double shift_value_E, shift_value_N;
      String NameGrid="";
      int error=0;
      //{Conversion degrees to radians}
      phi=phi*Math.PI/180;
      la=la*Math.PI/180;
      //{Conversion GRS80 to Oblique Stereographic}
      Stereo_FiLa_NE stFiLaNE=new Stereo_FiLa_NE(dV.A_ETRS89, dV.INV_F_ETRS89); 
      stFiLaNE.doConversion1(phi,la);
      NorthS=stFiLaNE.getNorth();
      EastS=stFiLaNE.getEast();
      //{Transformation Oblique Stereographic (GRS80) to Stereographic 1970 or 1930}
      if (type70or30==70){
         Helmert2D H2D=new Helmert2D(dV.tE_OS_St70, dV.tN_OS_St70, dV.dm_OS_St70,
                                     dV.Rz_OS_St70);
         H2D.doTransformation(EastS, NorthS);
         East=H2D.getEastt();
         North=H2D.getNortht();
         NameGrid=dV.NameFilegrd_R;
      }
      if (type70or30==30){
         Helmert2D H2D=new Helmert2D(dV.tE_OS_St30, dV.tN_OS_St30, dV.dm_OS_St30,
                                     dV.Rz_OS_St30);
         H2D.doTransformation(EastS, NorthS);
         East=H2D.getEastt();
         North=H2D.getNortht();
         NameGrid=dV.NameFilegrd_B;
      }
      Interpolation_2D int2D=new Interpolation_2D(East, North, NameGrid);
      error=int2D.doInterpolation();
      if (error==0){
         shift_value_E=int2D.getShift_value_E();
         shift_value_N=int2D.getShift_value_N();
         East=East+shift_value_E;
         North=North+shift_value_N; 
      }
      else{
         return -1;  
      }
      return 0; 
   }
   private double East;
   private double North;  
}

//{Transformation Stereografic 1970 or Stereografic 1930 to ETRS89}
class Stereo70or30ETRS89{
   public double getphi() //{=> phi in degrees}
   {
      return phi;
   } 
   public double getla() //{=> la in degrees} 
   {
      return la;
   }
   public int doTransformation(double East, double North, int type70or30) {
   // Note: x_Stereo70=North, yStereo70=East; x_Stereo30=East, y_stereo30=North       
   //       type70or30=70 for Stereo70, and type70or30=30 for Stereo30
      double EastS=0, NorthS=0;
      double shift_value_E, shift_value_N;
      String NameGrid="";
      int error=0;
      if (type70or30==70){
         NameGrid=dV.NameFilegrd_R;
      }
      if (type70or30==30){
         NameGrid=dV.NameFilegrd_B;
      }
      Interpolation_2D int2D=new Interpolation_2D(East, North, NameGrid);
      error=int2D.doInterpolation();
      if (error==0){
         shift_value_E=int2D.getShift_value_E();
         shift_value_N=int2D.getShift_value_N();
         East=East-shift_value_E;
         North=North-shift_value_N;
      }
      else{
         return -1;  
      }
      //{Transformation Stereographic 1970 or 1930 to Oblique Stereographic (GRS80)}
      if (type70or30==70){
         Helmert2D H2D=new Helmert2D(dV.tE_St70_OS, dV.tN_St70_OS, dV.dm_St70_OS, 
                                     dV.Rz_St70_OS);
         H2D.doTransformation(East, North);
         EastS=H2D.getEastt();
         NorthS=H2D.getNortht();
      }
      if (type70or30==30){
         Helmert2D H2D=new Helmert2D(dV.tE_St30_OS, dV.tN_St30_OS, dV.dm_St30_OS, 
                                     dV.Rz_St30_OS);
         H2D.doTransformation(East, North);
         EastS=H2D.getEastt();
         NorthS=H2D.getNortht();
      }
      //{Conversion Oblique Stereographic to GRS80}
      Stereo_NE_FiLa stNEFiLa=new Stereo_NE_FiLa(dV.A_ETRS89, dV.INV_F_ETRS89);
      stNEFiLa.doConversion2 (NorthS, EastS);
      //{=> (phi, la) in radians}
      phi=stNEFiLa.getFi();
      la=stNEFiLa.getLa();
      //{Conversion radians to degrees}
      phi=phi*180/Math.PI;
      la=la*180/Math.PI;
      return 0; 
   }
   private double phi;
   private double la;  
}
class ETRS89Stereo7030HMN{ //Compound Transformation 2D+1D
   public double getEast()
   {
      return East;
   } 
   public double getNorth()
   {
      return North;
   }
   public double gethMN() 
   {
      return hMN;
   }
   public int doCompTrans(double phi, double la, double h, int type70or30){
      int error=0;
      ETRS89HMN eHMN=new ETRS89HMN();
      error=eHMN.doTransformation(phi, la, h);
      if (error==0){
         hMN=eHMN.gethMN();
      }
      else {
          return -1;  
      }
      ETRS89Stereo70or30 eSt=new ETRS89Stereo70or30();
      error=eSt.doTransformation(phi, la, type70or30);
      if (error==0){
            East=eSt.getEast();
            North=eSt.getNorth(); 
      }
      else {
         return -1; 
      }
      return 0;
   } 
   private double East; 
   private double North; 
   private double hMN; 
}

class Stereo7030HMNETRS89{ //Compound Transformation 2D+1D
   public double getphi() 
   {
      return phi;
   } 
   public double getla() 
   {
      return la;
   }
   public double geth() 
   {
      return h;
   }
   public int doCompTrans(double East, double North, double hMN, int type70or30){
      int error=0;
      Stereo70or30ETRS89 stE=new Stereo70or30ETRS89();
      error=stE.doTransformation(East, North, type70or30);  
      if (error==0){
         phi=stE.getphi();
         la=stE.getla();
      }
      else{
         return -1; 
      }
      HMNETRS89 hMNE=new HMNETRS89();
      error=hMNE.doTransformation(phi, la, hMN);
      if (error==0){
         h=hMNE.geth();
      }
      else{
         return -1; 
      }
      return 0;
   } 
   private double phi; 
   private double la; 
   private double h;   
}
